require 'roda'
require_relative 'lib/cat_contract'
require_relative 'lib/cat_list'
require_relative 'helpers/contract_helper'
require_relative 'helpers/successfull_result'

class App < Roda
  plugin :hash_routes
  plugin :public
  plugin :render
  plugin :view_options
  
  include ContractHelper

  opts[:cats] = CatList.new
  opts[:cats].fill_with_random_cats

  require_relative 'routes/cats_route'

  route do |r|
    @title = 'О пушистиках'
    r.public

    r.hash_branches

    r.root do
      r.redirect '/cats'
    end
  end
end
