require 'dry-validation'

class CatContract < Dry::Validation::Contract
  params do
    required(:name).filled(:string)
    required(:age).value(:integer)
    required(:color).filled(:string)
    required(:weight).value(:float)
    required(:fluffiness).filled(:string)
  end

  rule(:weight) do
    if value < 0
      key.failure('Котики материальны. Они должны сколько-то весить!')
    end
  end
end
