require_relative 'cat'
require 'date'

class CatList
  PAGE_SIZE = 10

  def initialize
    @cats = []
  end

  def fill_with_random_cats
    names = %w[игорь вася мурсик жора леопольд барсик мурка буся снежинка]
    colors = %w[рыжий коричневый серый чёрный белый черепаховый леопардовый]
    fluffs = %w[лысый короткошёрстный длинношёрстный обычный]

    today = Date.today
    100.times do
      @cats.append(Cat.new(
        names[rand(names.size)],
        today - rand(365 * 15),
        colors[rand(colors.size)],
        fluffs[rand(fluffs.size)],
        3 + rand * 8
      ))
    end
  end

  def each(&block)
    @cats.each(&block)
  end

  def cat_by_id(cat_id)
    @cats[cat_id]
  end

  def delete_by_index(cat_id)
    @cats.delete_at(cat_id)
  end

  def cats_on_page(page_num)
    @cats.slice(page_num * PAGE_SIZE, PAGE_SIZE)
  end

  def pages_count
    if (@cats.size % PAGE_SIZE).zero?
      @cats.size / PAGE_SIZE - 1
    else
      @cats.size / PAGE_SIZE
    end
  end
end
