class App
  hash_branch('cats') do |r|
    set_view_subdir 'cats'
    set_layout_options template: '../views/layout' # Broken!!!

    r.is do
      r.get do
        @page_number = r.params['page_number']&.to_i || 0
        @pages_count = opts[:cats].pages_count
        @cats = opts[:cats].cats_on_page(@page_number)
        view :cats
      end
    end

    r.on Integer do |cat_id|
      @cat = opts[:cats].cat_by_id(cat_id)
      
      r.is do
        r.get do
          @index = cat_id
          view :cat
        end
      end

      r.on 'delete' do
        r.get do
          view :delete_form
        end
        
        r.post do
          opts[:cats].delete_by_index(cat_id)
          r.redirect '/cats'
        end
      end
    end

    r.on 'new' do
      r.get do
        @result = SuccessfullResult.new
        view :cat_form
      end

      r.post do
        @result = validate_contract(CatContract, r.params)
        if @result.failure?
          view :cat_form
        else
          r.redirect '/cats'
        end
      end
    end
  end
end
